<template>
  <div class="contract-locations">
    <ObTable
      v-if="serviceLocations.length"
      ref="directionTable"
      :columns="columns"
      :page-limit="15"
      :items="serviceLocations"
      :functional-panel="false"
      add-button-text="Добавить локацию"
      data-qa="contractDirectionsTable"
      @select="selectLocation"
    >
      <template slot="deleteButton" slot-scope="{ data }">
        <button
          v-if="isDraft"
          class="delete-button"
          @click="deleteLocation(data.item)"
        >
          <i class="icon close" />
        </button>
      </template>
    </ObTable>
    <div
      v-if="!serviceLocations.length"
      class="no-data-text"
    >
      Сейчас услуга действует для всех локаций по указанному тарифу.<br>
      Добавьте локации, чтобы настроить для них стоимость.
    </div>

    <ObButton
      v-if="isDraft"
      label="Добавить локацию"
      icon="plus"
      :mini="true"
      class="contract-directions__add-button"
      @click="onAddLocation"
    />

    <ObModal
      ref="locationModal"
      :title-second="titleSecondModal"
      :title="titleModal"
      size="large"
      data-qa="contractLocation"
    >
      <LocationForm
        :data-source="editedData"
        :service="service"
        @on-disable-location="deleteLocation"
        @submit="saveLocation"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import { mapState, mapGetters, mapMutations } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import LocationForm from '@/components/Contract/detail/services/locationsNew/Form'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  name: 'ContractLocationsList',
  components: {
    ObTable,
    LocationForm,
    ObModal,
    ObButton
  },
  props: {
    service: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      api,
      editedData: {},
      serviceLocations: []
    }
  },
  mounted () {
    this.getServiceLocations()
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract
    }),
    ...mapGetters({
      isDraft: 'contract/isDraft',
      isVatPayer: 'contract/isDoerVatPayer'
    }),
    columns () {
      return [
        {
          title: 'Локация',
          key: 'locationTitle',
          html: (data) => {
            return data.locationTitle
          }
        },
        {
          title: 'Тариф (без ндс)',
          key: 'tariffWithoutVat',
          html: (data) => this.tariffHtml(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: this.getNdsTitle(),
          key: 'vatAmount',
          html: (data) => this.ndsHtml(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: 'Итоговый тариф',
          key: 'tariff',
          html: (data) => this.totalPrice(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: ' ',
          slotName: 'deleteButton',
          sortDisable: true,
          action: true,
          width: 40
        }
      ]
    },
    serviceTitleByType () {
      if (!this.service.type) return ''
      let types = [
        {
          uuid: 'SIMPLE',
          title: 'Базовые'
        },
        {
          uuid: 'MULTISTOP',
          title: 'Мультистоповые',
          isDisabled: true
        },
        {
          uuid: 'MULTIMODAL',
          title: 'Мультимодальные',
          isDisabled: true
        },
        {
          uuid: 'ADDITIONAL',
          title: 'Дополнительные',
          isDisabled: true
        }
      ]

      return types.find((item) => item.uuid === this.service.type).title
    },
    titleModal () {
      return this.editedData.locationUuid ? `Локация «${this.editedData.locationTitle}»` : 'Локация'
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedData.locationUuid ? 'Редактирование' : 'Добавление'
    }
  },
  methods: {
    ...mapMutations({
      setViewState: 'contract/setViewState'
    }),
    async getServiceLocations () {
      const res = await api.contract.getServiceLocations({ uuid: this.service.uuid })
      this.serviceLocations = res.content
    },
    onAddLocation () {
      this.editedData = {}
      this.$refs.locationModal.open()
    },
    async deleteLocation ({ uuid }) {
      try {
        await api.contract.deleteLocation({ uuid })
        this.$notification({
          type: 'system_notification_success',
          message: `Локация удалена`
        })
        setTimeout(() => {
          this.getServiceLocations()
          this.$emit('on-update')
        }, 1000)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка удаления локации`
        })
      }
    },
    async saveLocation ({ formData }) {
      formData.serviceUuid = this.service.uuid
      try {
        if (this.editedData.uuid) {
          await api.contract.updateLocation({ data: formData, uuid: this.editedData.uuid })
        } else {
          await api.contract.createLocation({ data: { ...formData, serviceUuid: this.service.uuid } })
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Локация ${this.editedService ? 'обновлена' : 'добавлена'}`
        })
        this.$refs.locationModal.close()
        setTimeout(() => {
          this.getServiceLocations()
          this.$emit('on-update')
        }, 1000)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} локации`
        })
      }
    },
    async selectLocation ({ uuid }) {
      try {
        let res = await api.contract.getLocationDetail({ uuid })

        res = {
          ...res,
          ...res.tariffs
        }
        this.editedData = { ...res }
        this.$refs.locationModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных локации`
        })
      }
    },
    getDropdownItems (data) {
      if (!this.isDraft) {
        return []
      }
      return [
        {
          title: 'Удалить локацию',
          className: 'menu-button-danger',
          method: () => this.deleteLocation({ uuid: data.item.uuid })
        }
      ]
    },
    toHtml (data) {
      return `<div class="cell-to-location"><i class="icon ${data.to_icon}"></i><span>${data.to}</span></div>`
    },
    tariffHtml (data) {
      if (!data.tariffWithoutVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariffWithoutVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    ndsHtml (data) {
      return this.isVatPayer ? (formatNumber(data.vatAmount / 100, { dot: 2 }) + ' ₽') : `<span class="-gray-window">Не облагается</span>`
    },
    totalPrice(data) {
      if (!data.tariff) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    getNdsTitle () {
      if (!this.isVatPayer) {
        return 'НДС'
      }
      return this.service.isVatInclude
        ? 'в том числе НДС ' + (this.service.vatRate || 20) + '%'
        : 'НДС ' + (this.service.vatRate || 20) + '%'
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import "~common-components/src/static/css/mixins";
  .contract-locations {
    padding: 10px 0 30px 80px;
    .no-data-text {
      margin-bottom: 20px;
      margin-top: 10px;
      @include font-mixin(14px, 18px, 400, $color-grey-label);
    }
  }
</style>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import "~common-components/src/static/css/mixins";
  .contract-locations {
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .delete-button {
      margin: 0;
      padding: 3px;
      background-color: transparent;
      border: none;
      outline: none;
      cursor: pointer;
      .icon {
        font-size: 16px;
        color: $color-grey-span;
      }
      &:hover {
        .icon {
          color: $color-error;
        }
      }
    }

    &::v-deep {
      .ob-table-inner {
        margin-bottom: 20px;
        flex-grow: 2;
        .ob-menu-dropdown-container:not(.--opened) {
          opacity: 0;
          pointer-events: none;
        }
        tr th {
          border-top: none!important;
          box-shadow: none!important;
          border-bottom: 1px $lavender solid;
        }
        tr:hover {
          .ob-menu-dropdown-container {
            opacity: 1;
            pointer-events: all;
          }
        }
        td {
          &:last-child {
            .td-container {
              justify-content: flex-end;
            }
          }
        }
        .cell-to-location {
          display: flex;
          align-items: center;
          .icon {
            margin-right: 10px;
            font-size: 14px;
            color: $color-blue-navy-blue;
          }
        }
      }
    }
  }
</style>
